#ifdef __VIRTUAL__
  #undef AccountProfit
  #undef AccountBalance
  #undef AccountEquity

  #define AccountEquity AccountEquity2
  #define AccountBalance AccountBalance2
  #define AccountProfit AccountProfit2

  #include <KimIVToMT5.mqh> // https://www.mql5.com/ru/forum/93352/page32#comment_10603352

  #undef AccountProfit
  #undef AccountBalance
  #undef AccountEquity

  #define AccountBalance VIRTUAL::VirtualAccountBalance
  #define AccountEquity  VIRTUAL::VirtualAccountEquity
  #define AccountProfit  VIRTUAL::VirtualAccountProfit
#else // __VIRTUAL__
  #define MT4_TICKET_TYPE //  OrderSend  OrderTicket     ,   MT4 - int.
  #include <KimIVToMT5.mqh> // https://www.mql5.com/ru/forum/93352/page32#comment_10603352
#endif // __VIRTUAL__

#define CORNER_LEFT_LOWER  2
#define CORNER_LEFT_UPPER  0
#define CORNER_RIGHT_LOWER 3
#define CORNER_RIGHT_UPPER 1
#define CORNER(A) ((A) ? ((A) + 1) % 3 + 1 : 0)

bool ObjectSetInteger2( const long, const string name, const ENUM_OBJECT_PROPERTY_INTEGER property, const long value )
{
  return((property != OBJPROP_CORNER) ? ObjectSetInteger(0, name, property, value)
                                      : ObjectSetInteger(0, name, OBJPROP_CORNER, CORNER(value)) &&
                                        ObjectSetInteger(0, name, OBJPROP_ANCHOR, CORNER(value) << 1));
}

#undef CORNER
#define ObjectSetInteger ObjectSetInteger2

bool ObjectSet( const string name, const ENUM_OBJECT_PROPERTY_INTEGER property, const long value )
{
  return(ObjectSetInteger(0, name, property, value));
}

bool ObjectSet( const string name, const ENUM_OBJECT_PROPERTY_DOUBLE property, const double value )
{
  return(ObjectSetDouble(0, name, property, value));
}

template <typename T>
bool ObjectCreate(const string name, const T type, const int subwindow, const datetime time1, const double price1,
                                                                        const datetime time2 = NULL, const double price2 = NULL,
                                                                        const datetime time3 = NULL, const double price3 = NULL)
{
  return(ObjectCreate(0, name, (ENUM_OBJECT)type, subwindow, time1, price1, time2, price2));
};

bool ObjectSetText( const string name, const string text,
                    const int font_size = 0, const string font_name = NULL, const color Color = clrNONE )
{
  return(ObjectSetString(0, name, OBJPROP_TEXT, text) &&
         ((font_name == NULL) || ObjectSetInteger(0, name, OBJPROP_FONTSIZE, font_size)) &&
         ((font_name == NULL) || ObjectSetString(0, name, OBJPROP_FONT, font_name)) &&
         ((Color == clrNONE) || ObjectSetInteger(0, name, OBJPROP_COLOR, Color)));
}

int ObjectFind( const string Name ) { return(ObjectFind(0, Name)); }
bool ObjectsDeleteAll( const long, const ENUM_OBJECT Type ) { return((bool)ObjectsDeleteAll(0, -1, Type)); }
bool ObjectDelete( const string Name ) { return(ObjectDelete(0, Name)); }

string StringConcatenate2( const string Str1, const string Str2 ) { return(Str1 + Str2); }
string StringConcatenate2( const string Str1, const int Str2 ) { return(Str1 + (string)Str2); }
string StringConcatenate2( const string Str1, const int Str2, const string Str3, const string Str4 = NULL ) { return(Str1 + (string)Str2 + Str3 + Str4); }
#define StringConcatenate StringConcatenate2

#define Magic iMagic
#define val sval
#define X iX
#define Y iY
  #include "cm ea manual grid.mq4" // https://www.mql5.com/ru/code/24675
#undef Y
#undef X
#undef val
#undef Magic
